Index: meson/arch/ia32/meson.build
===================================================================
--- meson/arch/ia32/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/ia32/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -35,6 +36,5 @@
 
 arch_uspace_c_args = [
-	# FIXME: enabling -march for uspace makes malloc tests crash. Investigate.
-	# _march,
+	_march,
 	'-D__LE__',
 	'-mno-tls-direct-seg-refs',
@@ -51,10 +51,8 @@
 ]
 
-
-# TODO: Enable --gc-sections.
-arch_kernel_link_args = [ '-nostdlib', '-Wl,--no-gc-sections' ]
+arch_kernel_link_args = [ '-nostdlib' ]
 arch_uspace_link_args = [ '-nostdlib', '-lgcc' ]
 
-
+# Binaries to be included in a barebone build
 rd_essential += [
 	'app/edit',
@@ -63,9 +61,12 @@
 
 	'srv/audio/hound',
+]
 
+# Drivers to be included in a barebone build
+rd_essential_drv += [
 	'drv/intctl/apic',
 	'drv/intctl/i8259',
 	'drv/platform/pc',
-	'drv/block/ata_bd',
+	'drv/block/isa-ide',
 	'drv/bus/pci/pciintel',
 	'drv/bus/isa',
@@ -75,2 +76,40 @@
 	'drv/hid/xtkbd',
 ]
+
+# Drivers to be included in a regular build
+rd_drv += [
+	'drv/audio/hdaudio',
+	'drv/audio/sb16',
+	'drv/block/ahci',
+	'drv/block/isa-ide',
+	'drv/block/pci-ide',
+	'drv/block/usbmast',
+	'drv/block/virtio-blk',
+	'drv/bus/isa',
+	'drv/bus/pci/pciintel',
+	'drv/bus/usb/ehci',
+	'drv/bus/usb/ohci',
+	'drv/bus/usb/uhci',
+	'drv/bus/usb/usbdiag',
+	'drv/bus/usb/usbflbk',
+	'drv/bus/usb/usbhub',
+	'drv/bus/usb/usbmid',
+	'drv/bus/usb/vhc',
+	'drv/bus/usb/xhci',
+	'drv/char/i8042',
+	'drv/char/ns8250',
+	'drv/char/pc-lpt',
+	'drv/hid/ps2mouse',
+	'drv/hid/xtkbd',
+	'drv/hid/usbhid',
+	'drv/intctl/apic',
+	'drv/intctl/i8259',
+	'drv/nic/ar9271',
+	'drv/nic/e1k',
+	'drv/nic/ne2k',
+	'drv/nic/rtl8139',
+	'drv/nic/rtl8169',
+	'drv/nic/virtio-net',
+	'drv/platform/pc',
+	'drv/time/cmos-rtc',
+]
Index: meson/arch/ia64/meson.build
===================================================================
--- meson/arch/ia64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/ia64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -35,11 +36,14 @@
 arch_boot_c_args = [ '-D__LE__', '-fno-unwind-tables', '-mfixed-range=f32-f127', '-mno-pic', '-mno-sdata' ]
 
+# work around GCC bug 112604
+arch_uspace_c_args += ['-fno-unswitch-loops']
+
 arch_uspace_link_args = [ '-nostdlib', '-lgcc' ]
-arch_kernel_link_args = [ '-nostdlib', '-Wl,-EL' ]
-arch_boot_link_args = []
+arch_kernel_link_args = [ '-nostdlib', '-Wl,-EL', '-Wl,--no-warn-rwx-segments']
+arch_boot_link_args = ['-Wl,--no-warn-rwx-segments']
 
 
 if MACHINE == 'i460GX'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/platform/pc',
 		'drv/bus/pci/pciintel',
@@ -50,5 +54,5 @@
 
 elif MACHINE == 'ski'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/char/ski-con',
 		'drv/platform/ski',
@@ -56,2 +60,4 @@
 
 endif
+
+rd_drv += rd_essential_drv
Index: meson/arch/mips32/meson.build
===================================================================
--- meson/arch/mips32/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/mips32/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -60,14 +61,11 @@
 arch_boot_link_args = []
 
-
-kernel_as_prolog = '.module softfloat;'
 uspace_as_prolog = '.module softfloat;.abicalls;'
 
-
 if MACHINE == 'bmalta' or MACHINE == 'lmalta'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/platform/malta',
 		'drv/intctl/i8259',
-		'drv/block/ata_bd',
+		'drv/block/isa-ide',
 		'drv/bus/pci/pciintel',
 		'drv/bus/isa',
@@ -79,5 +77,5 @@
 
 elif MACHINE == 'msim'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/platform/msim',
 		'drv/block/ddisk',
@@ -86,2 +84,4 @@
 
 endif
+
+rd_drv += rd_essential_drv
Index: meson/arch/ppc32/meson.build
===================================================================
--- meson/arch/ppc32/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/ppc32/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2023 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -27,17 +28,19 @@
 #
 
-# FIXME: enable --gc-sections
-
 _common_c_args = [ '-D__BE__', '-fno-omit-frame-pointer', '-m32', '-Wa,-a32', '-mcpu=powerpc' ]
 
-arch_kernel_c_args = _common_c_args + [ '-msoft-float', '-fno-function-sections' ]
+arch_kernel_c_args = _common_c_args + [ '-msoft-float' ]
 arch_uspace_c_args = _common_c_args + [ CONFIG_FPU ? '-mhard-float' : '-msoft-float' ]
 arch_boot_c_args = arch_kernel_c_args
-arch_kernel_link_args = [ '-nostdlib', '-Wl,-z,max-page-size=0x1000', '-Wl,--no-check-sections', '-Wl,--no-gc-sections' ]
+arch_kernel_link_args = [ '-nostdlib', '-Wl,-z,max-page-size=0x1000' ]
 arch_uspace_link_args = [ '-nostdlib', '-lgcc', '-Wl,-z,max-page-size=0x1000' ]
-arch_boot_link_args = []
-
+arch_uspace_link_args += ldflags_ignore_rwx_segments
+arch_boot_link_args = ldflags_ignore_rwx_segments
 
 rd_essential += [
+	'app/ofw'
+]
+
+rd_essential_drv += [
 	'drv/platform/mac',
 	'drv/bus/adb/cuda_adb',
@@ -54,2 +57,4 @@
 	'drv/hid/usbhid',
 ]
+
+rd_drv += rd_essential_drv
Index: meson/arch/riscv64/meson.build
===================================================================
--- meson/arch/riscv64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/riscv64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -32,6 +33,8 @@
 arch_kernel_link_args = [ '-nostdlib' ]
 arch_uspace_link_args = [ '-nostdlib', '-lgcc' ]
-arch_boot_link_args = []
+arch_boot_link_args = ldflags_ignore_rwx_segments
 
 rd_essential += [
 ]
+
+rd_drv += rd_essential_drv
Index: meson/arch/sparc64/meson.build
===================================================================
--- meson/arch/sparc64/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/arch/sparc64/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 #
+# Copyright (c) 2023 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -75,12 +76,15 @@
 endif
 
+rd_essential += [
+	'app/ofw'
+]
 
 if PROCESSOR == 'sun4v'
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/platform/sun4v',
 		'drv/char/sun4v-con',
 	]
 else
-	rd_essential += [
+	rd_essential_drv += [
 		'drv/platform/sun4u',
 		'drv/bus/pci/pciintel',
@@ -88,4 +92,9 @@
 		'drv/intctl/obio',
 		'drv/char/ns8250',
+		'drv/char/i8042',
+		'drv/hid/ps2mouse',
+		'drv/hid/xtkbd',
 	]
 endif
+
+rd_drv += rd_essential_drv
Index: meson/part/compiler_args/meson.build
===================================================================
--- meson/part/compiler_args/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/part/compiler_args/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -60,5 +60,4 @@
 	'-Wall',
 	'-Wextra',
-	'-Werror-implicit-function-declaration',
 	'-Wwrite-strings',
 	'-Wunknown-pragmas',
@@ -69,6 +68,8 @@
 
 	'-ffunction-sections',
+	'-fdata-sections',
 	'-fno-common',
-	'-fdebug-prefix-map=' + meson.source_root() + '=.',
+	'-fdebug-prefix-map=' + meson.source_root() + '/=',
+	'-fdebug-prefix-map=../../=',
 ]
 
@@ -87,9 +88,10 @@
 
 if CONFIG_LINE_DEBUG
-	extra_common_flags += [ '-gdwarf-4', '-g3' ]
+	extra_common_flags += [ '-gdwarf-5', '-g3' ]
 endif
 
 extra_cflags = extra_common_flags + [
 	'-Wmissing-prototypes',
+	'-Werror-implicit-function-declaration',
 
 	'-Wno-missing-braces',
@@ -110,4 +112,5 @@
 extra_cppflags = extra_common_flags + [
 	'-fno-exceptions',
+	'-Wno-misleading-indentation',
 	'-frtti',
 ]
@@ -128,2 +131,15 @@
 	add_project_link_arguments(extra_cflags, language : [ lang ])
 endforeach
+
+# This flag is needed at several places, hence we define it here.
+#
+# For backwards compatibility we try to detect --no-warn-rwx-segments.
+# However, the autodetection done by Meson also results in
+# "cannot find entry symbol _start; defaulting to 00000000004000b0"
+# thus the option is never supported alone. So when detecting we also
+# specify --entry=main so that the stub source provided by Meson is build
+# correctly.
+ldflags_ignore_rwx_segments = []
+if cc.has_link_argument('-Wl,--no-warn-rwx-segments,--entry=main')
+    ldflags_ignore_rwx_segments += ['-Wl,--no-warn-rwx-segments']
+endif
Index: meson/part/exports/copy-export.sh
===================================================================
--- meson/part/exports/copy-export.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ meson/part/exports/copy-export.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,70 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2024 Vojtech Horky
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+set -ue
+
+target_dir="${DESTDIR:-export-dev}"
+
+rm -rf "${target_dir:?}/lib"
+rm -rf "${target_dir}/include"
+
+mkdir -p "${target_dir}/lib"
+mkdir -p "${target_dir}/include"
+
+
+while [ "$#" -gt 0 ]; do
+    case "$1" in
+        staticlib)
+            ar -t "$2" | xargs ar crs "${target_dir}/lib/$3"
+            ;;
+        include)
+            mkdir -p "${target_dir}/include/$3"
+            cp -r -L -t "${target_dir}/include/$3" "$2"/*
+            ;;
+        includesymlink)
+            (
+                cd "${target_dir}/include/$3" && ln -s "../$2" .
+            )
+            ;;
+        includenamedsymlink)
+            (
+                cd "${target_dir}/include/" && ln -s "$2" "$3"
+            )
+            ;;
+        config)
+            cp -L "$2" "${target_dir}/$3"
+            ;;
+        *)
+            echo "Unknown type $1, aborting." >&2
+            exit 1
+            ;;
+    esac
+    shift 3
+done
Index: meson/part/exports/meson.build
===================================================================
--- meson/part/exports/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/part/exports/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -85,2 +85,12 @@
 	capture: true,
 )
+
+run_target('export-dev',
+    command: [
+        sh,
+        meson.source_root() / 'meson' / 'part' / 'exports' / 'copy-export.sh',
+    ] + [
+        'config', config_mk, 'config.mk',
+        'config', config_sh, 'config.sh',
+    ] + exported_devel_files
+)
Index: meson/part/extra_targets/meson.build
===================================================================
--- meson/part/extra_targets/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/part/extra_targets/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -34,5 +34,5 @@
 		'--',
 		meson.build_root(),
-		config_py.path(),
+		config_py.full_path(),
 		meson.source_root() / 'HelenOS.config',
 		meson.source_root() / 'defaults',
@@ -51,5 +51,5 @@
 			'--',
 			meson.build_root(),
-			config_py.path(),
+			config_py.full_path(),
 			meson.source_root() / 'HelenOS.config',
 			meson.source_root() / 'defaults',
@@ -77,5 +77,5 @@
 		'--',
 		meson.source_root() / 'doxygen',
-		doxygen.path(),
+		doxygen.full_path(),
 		_dox_cfg,
 	])
Index: meson/part/initrd_manifest/meson.build
===================================================================
--- meson/part/initrd_manifest/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/part/initrd_manifest/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -29,4 +29,8 @@
 # Init binaries. These are actually baked into the bootloader.
 rd_init = [
+	# ELF file with DWARF debug sections for kernel.
+	# Kernel detects this entry by name.
+	'kernel.dbg',
+
 	# IMPORTANT: The order of entries is important for bootloader!
 	'srv/ns',
@@ -52,5 +56,7 @@
 	'srv/hid/output',
 	'srv/klog',
+]
 
+rd_essential_drv = [
 	'drv/root/root',
 	'drv/root/virt',
@@ -58,7 +64,9 @@
 ]
 
+rd_drv = rd_essential_drv
+
 if CONFIG_FB
 	rd_essential += [
-		'app/launcher',
+		'app/taskbar',
 		'app/terminal',
 
Index: meson/part/tools/meson.build
===================================================================
--- meson/part/tools/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ meson/part/tools/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -61,9 +61,15 @@
 endif
 
+# On some distributions (e.g. Arch Linux), genisoimage is actually a symbolic
+# link to mkisofs. However, they do not accept exactly the same options.
+# Thus we check if genisoimage is a symbolic link to mkisofs and if it is so,
+# we switch to mkisofs as that is the native application available.
+fs = import('fs')
 genisoimage = find_program('genisoimage', required: false)
-if genisoimage.found()
+_mkisofs = find_program('mkisofs', required: false)
+if genisoimage.found() and not (fs.is_symlink(genisoimage.full_path()) and _mkisofs.found() and fs.is_samepath(genisoimage.full_path(), _mkisofs.full_path()))
 	genisoimage_type = 'genisoimage'
 else
-	genisoimage = find_program('mkisofs', required: false)
+	genisoimage = _mkisofs
 	if genisoimage.found()
 		genisoimage_type = 'mkisofs'
Index: tools/build-ccheck.sh
===================================================================
--- tools/build-ccheck.sh	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/build-ccheck.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,5 +1,5 @@
 #!/bin/sh
 #
-# Copyright (c) 2019 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -29,5 +29,5 @@
 
 SYCEK_GIT="https://github.com/jxsvoboda/sycek"
-SYCEK_REV="14f0aadad8bb2f17eef030a74b3591377ad57343"
+SYCEK_REV="e606f73fd875b5d9ff48261b23f69552a893f5d4"
 
 if [ ! -d sycek ]; then
Index: tools/conf/msim.conf
===================================================================
--- tools/conf/msim.conf	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/conf/msim.conf	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -3,6 +3,6 @@
 #
 
-add dcpu cpu0
-add dcpu cpu1
+add dr4kcpu cpu0
+add dr4kcpu cpu1
 
 add rwm mainmem 0x00000000
Index: tools/ew.py
===================================================================
--- tools/ew.py	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/ew.py	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -79,5 +79,5 @@
 	for termemu in emus:
 		try:
-			subprocess.check_output('which ' + termemu, shell = True)
+			subprocess.check_output('which ' + termemu, shell = True, stderr = subprocess.STDOUT)
 			return termemu
 		except:
@@ -173,5 +173,8 @@
 			raise Exception
 		if processor == 'us':
-			return 'system-sparc64', '-M sun4u --prom-env boot-args="console=devices/\\hw\\pci0\\01:01.0\\com1\\a"'
+			cmdline = '-M sun4u'
+			if is_override('nographic'):
+			    cmdline += ' --prom-env boot-args="console=devices/\\hw\\pci0\\01:01.0\\com1\\a"'
+			return 'system-sparc64', cmdline
 
 		# processor = 'sun4v'
@@ -285,4 +288,5 @@
 	if (is_override('nographic')):
 		cmdline += ' -nographic'
+		console = True
 
 	if (not console and (not is_override('nographic')) and not is_override('noserial')):
@@ -327,5 +331,5 @@
 def msim_run(platform, machine, processor):
 	hdisk_mk()
-	run_in_console('msim -c ' + TOOLS_DIR + '/conf/msim.conf', 'HelenOS/mips32 on msim')
+	run_in_console('msim -n -c ' + TOOLS_DIR + '/conf/msim.conf', 'HelenOS/mips32 on msim')
 
 def spike_run(platform, machine, processor):
@@ -410,5 +414,5 @@
 				'image' : 'image.iso',
 				'audio' : False,
-				'console' : True,
+				'console' : False,
 				'net' : False,
 				'usb' : False,
@@ -418,5 +422,8 @@
 			'sun4v' : {
 				'run' : qemu_run,
-				'image' : '-drive if=pflash,readonly=on,file=image.iso',
+				# QEMU 8.0.0 ignores the 'file' argument and instead uses 'id',
+				# which defaults to 'pflash0', but can be changed to the same value
+				# as 'file'
+				'image' : '-drive if=pflash,id=image.iso,readonly=on,file=image.iso',
 				'audio' : False,
 				'console' : True,
Index: tools/export.sh
===================================================================
--- tools/export.sh	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/export.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -43,4 +43,5 @@
 	uspace/lib/libc.a \
 	uspace/lib/libcongfx.a \
+	uspace/lib/libconsole.a \
 	uspace/lib/libcpp.a \
 	uspace/lib/libdisplay.a \
@@ -48,8 +49,10 @@
 	uspace/lib/libgfxfont.a \
 	uspace/lib/libgfximage.a \
+	uspace/lib/libinput.a \
 	uspace/lib/libhound.a \
 	uspace/lib/libipcgfx.a \
 	uspace/lib/libmath.a \
 	uspace/lib/libmemgfx.a \
+	uspace/lib/liboutput.a \
 	uspace/lib/libpcm.a \
 	uspace/lib/libpixconv.a \
@@ -67,6 +70,15 @@
 ninja devel-headers
 
+#
+# Meson may produce thin archives. These cannot be simply copied to another
+# location. Copy them using ar instead, converting them to regular,
+# non-thin archives in the process.
+#
 mkdir -p "$EXPORT_DIR/lib"
-cp -t "$EXPORT_DIR/lib" $EXPORT_LIBS
+for lpath in $EXPORT_LIBS; do
+	dest="$EXPORT_DIR/lib/$(basename $lpath)"
+	ar -t $lpath | xargs ar crs $dest
+done
+
 rm -rf "$EXPORT_DIR/include"
 cp -R dist/include "$EXPORT_DIR/include"
Index: tools/list_profiles.sh
===================================================================
--- tools/list_profiles.sh	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/list_profiles.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -2,4 +2,5 @@
 
 #
+# Copyright (c) 2021 Jiri Svoboda
 # Copyright (c) 2019 Jiří Zárevúcky
 # All rights reserved.
@@ -39,4 +40,17 @@
 CONFIG_DEFAULTS="${SOURCE_DIR}/defaults"
 
-# Find all the leaf subdirectories in the defaults directory.
-find ${CONFIG_DEFAULTS} -type d -links 2 -printf "%P\n" | sort
+# Find the leaf subdirectories in the defaults directory.
+level1dirs=`ls "$CONFIG_DEFAULTS"`
+for dname in $level1dirs; do
+	l2dirs=`ls "$CONFIG_DEFAULTS"/"$dname"`
+	havel2=
+	for dn in $l2dirs; do
+		if [ -d "$CONFIG_DEFAULTS/$dname/$dn" ]; then
+			echo "$dname/$dn"
+			havel2=true
+		fi
+	done
+	if [ -z "$havel2" ]; then
+		echo "$dname"
+	fi
+done
Index: tools/mkarray.py
===================================================================
--- tools/mkarray.py	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/mkarray.py	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -39,8 +39,8 @@
 def usage(prname):
 	"Print usage syntax"
-	print("%s [--deflate] <DESTINATION> <LABEL> <AS_PROLOG> <SECTION> [SOURCE ...]" % prname)
+	print("%s [--deflate] <DESTINATION> <TYPENAME> <LABEL> <AS_PROLOG> <SECTION> [SOURCE ...]" % prname)
 
 def arg_check():
-	if (len(sys.argv) < 5):
+	if (len(sys.argv) < 6):
 		usage(sys.argv[0])
 		sys.exit()
@@ -66,7 +66,8 @@
 
 	dest = sys.argv[1]
-	label = sys.argv[2]
-	as_prolog = sys.argv[3]
-	section = sys.argv[4]
+	typename = sys.argv[2]
+	label = sys.argv[3]
+	as_prolog = sys.argv[4]
+	section = sys.argv[5]
 
 	timestamp = (1980, 1, 1, 0, 0, 0)
@@ -81,5 +82,5 @@
 	archive = zipfile.ZipFile("%s.zip" % dest, "w", zipfile.ZIP_STORED)
 
-	for src in sys.argv[5:]:
+	for src in sys.argv[6:]:
 		basename = os.path.basename(src)
 		plainname = os.path.splitext(basename)[0]
@@ -147,4 +148,6 @@
 	data += "#include <stdbool.h>\n\n"
 	data += "#define %sS  %u\n\n" % (label.upper(), src_cnt)
+	data += "#ifndef %sS_T_\n" % typename.upper()
+	data += "#define %sS_T_\n\n" % typename.upper()
 	data += "typedef struct {\n"
 	data += "\tconst char *name;\n"
@@ -153,6 +156,7 @@
 	data += "\tsize_t inflated;\n"
 	data += "\tbool compressed;\n"
-	data += "} %s_t;\n\n" % label
-	data += "extern %s_t %ss[];\n\n" % (label, label)
+	data += "} %s_t;\n\n" % typename
+	data += "#endif\n"
+	data += "extern %s_t %ss[];\n\n" % (typename, label)
 	data += "\n".join(header_ctx)
 	data += "\n\n"
@@ -179,5 +183,5 @@
 	data += ' */\n\n'
 	data += "#include \"%s.h\"\n\n" % dest
-	data += "%s_t %ss[] = {\n" % (label, label)
+	data += "%s_t %ss[] = {\n" % (typename, label)
 	data += ",\n".join(desc_ctx)
 	data += "\n"
Index: tools/mkarray_for_meson.sh
===================================================================
--- tools/mkarray_for_meson.sh	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ tools/mkarray_for_meson.sh	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -42,7 +42,8 @@
 _arg3="$4"
 _arg4="$5"
+_arg5="$6"
 _inputs=""
 
-shift 5
+shift 6
 
 for file in "$@"; do
@@ -51,3 +52,3 @@
 
 cd $_outdir
-$TOOLS_DIR/mkarray.py "$_arg1" "$_arg2" "$_arg3" "$_arg4" $_inputs > /dev/null
+$TOOLS_DIR/mkarray.py "$_arg1" "$_arg2" "$_arg3" "$_arg4" "$_arg5" $_inputs > /dev/null
